VERSION 5.00
Object = "{7020C36F-09FC-41FE-B822-CDE6FBB321EB}#1.2#0"; "VBCCR17.OCX"
Object = "{11B9E887-5331-431E-9348-BA3F6C1CB487}#1.3#0"; "KerCADe.ocx"
Begin VB.Form Form1 
   Caption         =   "Form1"
   ClientHeight    =   5760
   ClientLeft      =   60
   ClientTop       =   405
   ClientWidth     =   9420
   LinkTopic       =   "Form1"
   ScaleHeight     =   5760
   ScaleWidth      =   9420
   StartUpPosition =   3  'Windows Default
   Begin VBCCR17.CommandButtonW cmdCylinder 
      Height          =   495
      Left            =   120
      TabIndex        =   4
      Top             =   4320
      Width           =   1575
      _ExtentX        =   2778
      _ExtentY        =   873
      Caption         =   "Cylinders"
   End
   Begin VBCCR17.CommandButtonW cmdCut 
      Height          =   495
      Left            =   120
      TabIndex        =   3
      Top             =   4920
      Width           =   1575
      _ExtentX        =   2778
      _ExtentY        =   873
      Caption         =   "Void"
   End
   Begin VBCCR17.CommandButtonW cmdImport 
      Height          =   495
      Left            =   120
      TabIndex        =   2
      Top             =   720
      Width           =   1575
      _ExtentX        =   2778
      _ExtentY        =   873
      Caption         =   "Import (Component)"
   End
   Begin VBCCR17.CommandButtonW cmdClear 
      Height          =   495
      Left            =   120
      TabIndex        =   1
      Top             =   120
      Width           =   1575
      _ExtentX        =   2778
      _ExtentY        =   873
      Caption         =   "Clear"
   End
   Begin KERNELCADLib.KernelCAD MyKernelCAD 
      Height          =   5415
      Left            =   1800
      TabIndex        =   0
      Top             =   120
      Width           =   6975
      _Version        =   262147
      _ExtentX        =   12303
      _ExtentY        =   9551
      _StockProps     =   0
      ModelPath       =   ""
      PPBagVer        =   "PropSchema 6"
      ModelSize       =   "frmTest.frx":0000
      Mode5KC         =   458754
   End
   Begin VBCCR17.CommandButtonW cmdImportTest 
      Height          =   495
      Left            =   120
      TabIndex        =   5
      Top             =   1320
      Width           =   1575
      _ExtentX        =   2778
      _ExtentY        =   873
      Caption         =   "Import (Model)"
   End
   Begin VBCCR17.CommandButtonW cmdImportTest2 
      Height          =   495
      Left            =   120
      TabIndex        =   6
      Top             =   1920
      Width           =   1575
      _ExtentX        =   2778
      _ExtentY        =   873
      Caption         =   "Import (New Model Ent Array)"
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Private Sub cmdClear_Click()
    Dim iModel As IModel_DG
    Set iModel = MyKernelCAD.GetModel()
    Call iModel.RemoveAll(True)
    Set iModel = Nothing
    Call MyKernelCAD.UpdateView
    Call MyKernelCAD.UpdateSurface
End Sub

Private Sub cmdCut_Click()
    Call SetModelToVoid
    Call MyKernelCAD.UpdateView
End Sub

Private Sub SetModelToVoid()
    Dim iBlob As IBlob_DG
    Dim iModel As IModel_DG
    Dim iObjGen As IObjectGenerator_DG
    
    Set iModel = MyKernelCAD.GetModel()
    Set iObjGen = iModel
    
    Set iBlob = iObjGen.Create("IBlob_DG")
    Call iBlob.SetSize(1)
    Call iBlob.Set(0, 0)
    
    Call iModel.RemoveAll(True)
    
    If iModel.LoadFromMemory(iBlob, eCadFormatDgXYZ) Then
        Call MsgBox("True")
    End If
    
    Call iModel.RemoveAll(True)
    
    Set iBlob = Nothing
    Set iObjGen = Nothing
    Set iModel = Nothing
    



End Sub

Private Sub cmdCylinder_Click()
    Dim iStdShape As IStdShape_DG
    Dim iModel As IModel_DG
    Dim iEntity As IEntity_DG
    Dim iView As IView_DG
    
    Dim intIndex As Integer

    Set iModel = MyKernelCAD.GetModel()
    Set iStdShape = iModel
    
    Set iView = MyKernelCAD.GetView()
    For intIndex = 1 To 500
        Set iEntity = iStdShape.Cylinder(10, 20, 30)
        Call iModel.AddEntity(iEntity)
    Next
    

    
    Call iView.Reset(True, True)
    
    Call MyKernelCAD.UpdateView
    
    Set iEntity = Nothing
    Set iView = Nothing
    Set iStdShape = Nothing
    Set iModel = Nothing
    
    'Call TestBSplineCurve
    'Call BuildArcByRadius(400)
    'Call RotateEntity(MyModel3D.GetEntity("Component"))
    'Me.MyKernelCAD.UpdateView
    'Call FitAndUpdateView3D(Me)
End Sub

Private Sub cmdImport_Click()
    Dim strFilePath As String
    
    
    Dim blnReturn As Boolean
    Dim intIndex As Integer

    Dim MyObjGen3D As IObjectGenerator_DG
    Dim iModelStandalone As IModel_DG
    Dim iEntArray As IEntityArray_DG
    Dim MyDictionary As IDictionary_DG
    Dim MyComponentEntity As IEntity_DG
    
    Dim MyModel3D As IModel_DG
    Dim MyView3D As IView_DG
    
    Set MyModel3D = MyKernelCAD.GetModel()
    Set MyView3D = MyKernelCAD.GetView()
    
    Set MyObjGen3D = MyModel3D
    Set MyDictionary = MyObjGen3D.Create("IDictionary_DG")
    Call MyDictionary.SetBool("SeparateObjects", True)

    strFilePath = "Model_Overall2.stl"

    MyKernelCAD.ShowGlobalAxes = True
    

    
    Set MyObjGen3D = MyModel3D
    Set iModelStandalone = MyObjGen3D.Create("IModel_DG")
    
    blnReturn = iModelStandalone.Load(strFilePath)
    If (blnReturn = False) Then
        Debug.Print ("failed to load " & strFilePath)
    End If
    
    Set MyComponentEntity = MyObjGen3D.Create("IEntity_DG")
    Call MyComponentEntity.SetName("Component")
    
    Set iEntArray = iModelStandalone.GetEntityArray(True)
    Call MyComponentEntity.Add(iEntArray, -1)
    
    For intIndex = 0 To MyComponentEntity.GetChildCount - 1
        MyComponentEntity.GetChildAt(intIndex).SetName ("Child_" & intIndex)
    Next intIndex
    
    'Call MyModel3D.Add(iEntArray, -1)
    Call MyModel3D.AddEntity(MyComponentEntity)
    
    
    Screen.MousePointer = vbHourglass
    Call MyView3D.Reset(False, False)
    Call MyView3D.Zoom(1.5)
    MyKernelCAD.ShowGlobalAxes = True
    Call MyKernelCAD.UpdateView
    Screen.MousePointer = vbDefault
    
    'Call iEntArray.Clear
    'Call iModelStandalone.RemoveAll(True)
    'Call MyComponentEntity.RemoveAll(True)
    
    Set iEntArray = Nothing
    Set iModelStandalone = Nothing
    'Set MyComponentEntity = Nothing
    'Set MyObjGen3D = Nothing
    'Set MyModel3D = Nothing
    'Set MyView3D = Nothing

    
End Sub


Private Sub cmdImportTest_Click()
    ' This loads the file directly into the model by doing My3DModel.load(path)

    
    Dim iModel As IModel_DG
    Dim iView As IView_DG
    Dim strFilePath As String
    

    Set iModel = MyKernelCAD.GetModel()
    Set iView = MyKernelCAD.GetView()
    
    'strFilePath = "F:\HC Dev\ImportTest\Model_Overall2.stl"
    strFilePath = "Model_Overall2.stl"
    
    Call iModel.Load(strFilePath)

    Call iView.Reset(True, True)
    
    Call MyKernelCAD.UpdateView
    
End Sub

Private Sub cmdImportTest2_Click()

    'This loads the file into its own IModel_DG object, and then the entities from the loaded model are added
    'to the main model, and the standalone IModel_DG object is then unloaded

    Dim iModel As IModel_DG
    Dim iModelStandalone As IModel_DG
    Dim iEntArray As IEntityArray_DG

    Dim iView As IView_DG

    Dim iObjGen As IObjectGenerator_DG
    
    
    Dim strFilePath As String
    

    Set iModel = MyKernelCAD.GetModel()
    
    Set iView = MyKernelCAD.GetView()
    
    strFilePath = "Model_Overall2.stl"
    
    
    Set iObjGen = iModel
    Set iModelStandalone = iObjGen.Create("IModel_DG")
    'Set iObjGen = Nothing
    Call iModelStandalone.Load(strFilePath)

    
    Set iEntArray = iModelStandalone.GetEntityArray(True)
    
    Call iModel.Add(iEntArray, -1)
    
    'Call iModel.RemoveAll(True)

    
    Call iView.Reset(True, True)
    
    Call MyKernelCAD.UpdateView
    
    
    Call iEntArray.Clear
    Call iModelStandalone.RemoveAll(True)
    
    Set iModelStandalone = Nothing
    Set iEntArray = Nothing
    Set iObjGen = Nothing
    Set iView = Nothing
    Set iModel = Nothing
End Sub

Private Sub Form_Load()
    'Call InitKernelCAD(Me)
    
End Sub

Private Sub Form_Unload(Cancel As Integer)
    'Call ReleaseKernelCADObjects
    
End Sub
